unit msglog;
interface
uses sysutils,messages,windows;

// msglog
const
  WM_DMSGLOG = WM_USER+1;
  SHAREMEMSIZE = $4000;
type
  pMsgLogShareMem = ^TMsgLogShareMem;
  TMsgLogShareMem = record
    Id: integer;
    wnd: HWND;
    size: integer;
    Cnt: integer;
    Txt: array[0..16367]of char;
  end;

procedure LDebug(const S: string);overload;
procedure LDebug(const FormatStr: string; const Args: array of const);overload;

implementation
// msglog
procedure dMsgLog(sometext: PChar);stdcall;
var h:THandle; m: pMsgLogShareMem;
begin
  h := OpenFileMapping(FILE_MAP_WRITE,false,'dMsgLog');
  if h<>0 then begin
    m := MapViewOfFile(h,FILE_MAP_WRITE,0,0,SHAREMEMSIZE);
    if m<>nil then begin
      if m.Id = $9414703 then begin
        while m.Cnt+integer(StrLen(sometext))+18 >= m.size do begin
          SendMessage(m.wnd,WM_DMSGLOG,0,0);
          if integer(StrLen(sometext))+18 > m.size then sometext[m.size-18] := #0;
        end;
        StrCopy(@m.Txt[m.Cnt],sometext);
        inc(m.Cnt,StrLen(sometext)+1);
        PostMessage(m.wnd,WM_DMSGLOG,0,0);
      end;
      UnmapViewOfFile(m);
    end;
    CloseHandle(h);
  end;
end;

procedure LDebug(const S: string);overload;
begin
  dMsgLog(PChar(S));
end;

procedure LDebug(const FormatStr: string; const Args: array of const);overload;
begin
  LDebug(Format(FormatStr,Args));
end;

end.
